#include <iostream.h>
#include <fstream.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoFile.h>
#include <Inventor/nodes/SoSwitch.h>
#include <Inventor/sensors/SoTimerSensor.h>


////////////////////////////////////////////////////////////
//
// Kevin Beason 4/20/2000
//
// Makes animation out of different scene graphs stored
// in separate files.
//

int lastScene;
int index=-1;
SoSwitch *mySwitch;

char* tackOn(int c, char* a, char* b){
  int i;
  for (i=0;a[i];i++) b[i]=a[i];
  
  int ctemp=c, clen=1;
  while (ctemp=ctemp/10) clen++;
  ctemp=i;

  for (i=ctemp+clen-1;i>=ctemp;i--){
    b[i]=c%10+'0';
    c=c/10;
  }

  b[ctemp+clen]=0;

  return(b);
}

SoSeparator *
makeScene ()
  {
  SoSeparator *root = new SoSeparator();
  return root;
  }

void animate(void *data, SoSensor *){
  index++;
  if (index>lastScene) index=0;
  mySwitch->whichChild.setValue(index); 
}

void
main(int, char **argv)
  {
  Widget myWindow = SoXt::init(argv[0]);
  if (myWindow == NULL) exit(1);

  SoSeparator *root = makeScene();

  // Read scene graphs and add to children
  int i;
  //char fileNameBase[50]="/home/beason/sussman/isosurf/scene.iv.";
  char fileNameBase[50]="/rivera/a/beason/secondrun/scene.iv.";
  char fileName[50], temp[100];
  ifstream scene;

  for (i=0;;i++){
    scene.open(tackOn(i,fileNameBase,fileName));
    if (!scene) break;
    scene.close();
  }
  lastScene=i-1;
  cout << "Reading in scene graph files 0-" << lastScene
       << ":" << endl;

  mySwitch = new SoSwitch();
  SoFile *myFile = new SoFile();
  for (i=0;i<=lastScene;i++){
    cout << tackOn(i,fileNameBase,fileName) << "..." << endl;
    myFile->name.setValue(tackOn(i,fileNameBase,fileName));
    mySwitch->addChild(myFile->copyChildren());
  }
  mySwitch->whichChild.setValue(0);
  root->addChild(mySwitch);

  cout << "Type \"ok\" to start animation: ";
  cin >> temp;
  
  cout << "Starting animation." << endl;
  
  SoTimerSensor *sensor = new SoTimerSensor(animate, &root);
  sensor->setInterval(SbTime(1.0)); // 50 frames per second
  sensor->schedule();

  SoXtExaminerViewer *myViewer = new SoXtExaminerViewer(myWindow);
  myViewer->setSceneGraph(root);
  myViewer->setTitle("Inventor Template");
  myViewer->show();

  SoXt::show(myWindow);
  SoXt::mainLoop();
  }
