#include<fstream.h>
#include<stdio.h>

//
// Kevin Beason 4/19/2000
//
// Reads ASCII boat level input file and writes it out
// in binary for Amira to read.
//

int main(int argc, char* argv[]){

  // read in data
  typedef double vec3f[3];
  double boatlevel, trash;
  vec3f xmin, xmax;
  int imax, jmax, kmax;
  int i, j, k;
  char *inFileName  = "/home/beason/sussman/eblevel.dat";
  char *outFileName = "/home/beason/sussman/eblevel.dat.bin";
  char *reducedOutFileName = "/home/beason/sussman/eblevel.dat.2";
  
  // open input file
  cout << "Reading from data file: " << inFileName << endl;
  ifstream boatFile;
  boatFile.open(inFileName);
  
  // open output file
  cout << "Writing to data file: " << outFileName << endl;
  FILE *niceBoatFile;
  niceBoatFile=fopen(outFileName, "wb");

  // open reduced output file
  cout << "Writing reduced date to file: " << reducedOutFileName << endl;
  ofstream reducedOutFile(reducedOutFileName, ios::scientific);
  reducedOutFile.precision(16);

  // read in data
  boatFile >> imax >> jmax >> kmax;
  cout << "imax= " << imax << " jmax= " << jmax << " kmax= " << kmax << endl;
  boatFile >> trash >> trash >> trash;
  boatFile >> xmin[0] >> xmin[1] >> xmin[2];
  boatFile >> xmax[0] >> xmax[1] >> xmax[2];

  // write out reduced version of above data
  reducedOutFile << imax/2+imax%2 << " "
		 << jmax/2+jmax%2 << " "
		 << kmax/2+kmax%2 << endl;;
  reducedOutFile << trash << " " << trash << " " << trash << endl;
  reducedOutFile << xmin[0] << " " << xmin[1] << " " << xmin[2] << endl;
  reducedOutFile << xmax[0] << " " << xmax[1] << " " << xmax[2] << endl;
 
  // loop through input data and write out, in binary
  cout << "Reading i = (0.." << imax << ") ";
  for (i=0;i<imax;i++){
    cout << i << " " << flush;
    for (j=0;j<jmax;j++)
      for (k=0;k<kmax;k++){
	boatFile >> boatlevel;
	fwrite(&boatlevel, sizeof(boatlevel), 1, niceBoatFile);
	if (i%2==0 && j%2==0 && k%2==0){
	  reducedOutFile << boatlevel << endl;
	}
      }

  }

  cout << "\nClosing files: " << endl;
  cout << inFileName << endl;
  boatFile.close();
  cout << outFileName << endl;
  fclose(niceBoatFile);
  cout << reducedOutFileName << endl;
  reducedOutFile.close();
  
  cout << "Done.\n";
  return(0);
}
